################################################################################
##
##   R package clusrank by Mei-Ling Ting Lee, Jun Yan, and Yujing Jiang
##   Copyright (C) 2016
##
##   This file is part of the R package clusrank.
##
##   The R package clusrank is free software: you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as published
##   by the Free Software Foundation, either version 3 of the License, or
##   (at your option) any later version.
##
##   The R package clusrank is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
##   You should have received a copy of the GNU General Public License
##   along with the R package clusrank. If not, see <http://www.gnu.org/licenses/>.
##
################################################################################
#' Clustered Stratified Data for Testing the Clustered Rank Sum Test
#'
#' Stratified data with clustering structure, Have some missing values.
#'
#' @format
#' A data frame with 956 observations on 4 variables.
#'
#' [, 1] id      cluster id
#'
#' [, 2] z       score
#'
#' [, 3] group   group id
#'
#' [, 4] stratum stratum id
#'
#' @name crdStr
#' @docType data
#' @source \url{https://sites.google.com/a/channing.harvard.edu/bernardrosner/channing/incorporating-cluster-effects-for-the-wilcoxon-rank-sum-test-1/stratify--cluswilcox/sample-data}
#' @keywords datasets internal
NULL
